{*
 *
 *   PDFMaker
 *
 *   Copyright(c) 1999-2000 Takezou
 *
 *   PDFt@Co̓jbg
 *
 *   99.12.03 0.1  쐬
 *   99.12.08 0.2  vg^Cv̂܂Ƃ܂̂ŁAe𐮗
 *   99.12.10 0.21 Font̎ύX
 *   99.12.11 0.22 PDFContents(Canvas)̎Jn
 *   99.12.19 0.3  {tHg̎
 *   99.12.25 0.31 W`惋[`̎
 *   2000.01.28 0.32 TextWidth[`̎
 *   2000.02.02 0.33 ClipMeasureText̎
 *   2000.02.04 0.34 ArrangeText̒ǉ
 *   2000.02.08 0.4  񃊃[X
 *   2000.02.08 0.41 ׂC
 *   2000.02.29 0.5  OutLine̎
 *   2000.03.01 0.6  Image̎JniƂ肠Bitmapj
 *   2000.03.26 0.61 [hbvɋ֑̒ǉ
 *
 *}
unit PDFMaker;

interface

uses
  Windows, SysUtils, Classes, PMFonts, Graphics;

const
  PDFMAKER_VERSION_TEXT = 'PDFMaker0.61';

type
  TLineJoinStyle = (ljMiterJoin, ljRoundJoin, ljBevelJoin);

  TLineCapStyle = (lcButtEnd, lcRoundEnd, lcProjectingSquareEnd);

  TTextRenderingMode = (trFill,
                        trStroke,
                        trFillThenStroke,
                        trInvisible,
                        trFillClipping,
                        trStrokeClipping,
                        trFillStrokeClipping,
                        trClipping);

  TPDFRect = record
    Left, Top, Right, Bottom: Single;
  end;

  TPDFPoint = record
    X, Y: Single;
  end;

  TPDFXObjectHandle = integer;

  TPDFMaker = class;

  {*
   *  TPDFObject
   *  PDFt@C̃IuWFNg̊{^ObjectIDǗ
   *
   *}
  TPDFObject = class(TObject)
  private
    FObjectID: integer;
    FOwner: TPDFMaker;
    function GetObjectHeader: string;
    function GetObjectDetail: string; virtual;
  public
    constructor Create(AOwner: TPDFMaker); virtual;
    function GetObjectString: string;
    property ObjectID: integer read FObjectID;
  end;

  {*
   *  TPDFObjectList
   *  PDFt@C̃IuWFNg̏WǗB
   *
   *}
  TPDFObjectList = class(TObject)
  private
    FItems: TList;
    function GetItem(Index: integer): TPDFObject;
    function GetCount: integer;
  public
    constructor Create; virtual;
    procedure Clear;
    function AddItem(AItem: TPDFObject): integer; virtual;
    function GetArrayString: string;
    property Items[index: integer]: TPDFObject read GetItem; default;
    property Count: integer read GetCount;
    destructor Destroy; override;
  end;

  {*
   *  TPDFInfo
   *  InfoIuWFNgBǗIuWFNg
   *
   *}
  TPDFInfo = class(TPDFObject)
  private
    function GetObjectDetail: string; override;
  public
  end;

  TPDFPage = class;

  {*
   *  TPDFPages
   *  PagesIuWFNgBMediaboxPageIuWFNg̏WǗB
   *
   *}
  TPDFPages = class(TPDFObject)
  private
    FKids: TPDFObjectList;
    FHeight, FWidth: integer;
    procedure SetHeight(Value: integer);
    procedure SetWidth(Value: integer);
    function GetKids(Index: integer): TPDFObject;
    function GetObjectDetail: string; override;
  protected
    function AddPage: TPDFPage;
  public
    constructor Create(AOwner: TPDFMaker); override;
    property Kids[index: integer]: TPDFObject read GetKids; default;
    property Height: integer read FHeight write SetHeight;
    property Width: integer read FWidth write SetWidth;
  end;

  {*
   *  TPDFFontDescriptor
   *  FontDescriptorIuWFNgB
   *  tHg̏ǗB
   *  ۂ̏FontDescriptorDefɎ
   *
   *}
  TPDFFontDescriptor = class(TPDFObject)
  private
    FFontDescriptorDef: TPDFFontDescriptorDef;
    function GetObjectDetail: string; override;
  public
    destructor Destroy; override;
    procedure SetFontDescriptorDef(AFontDescriptorDef: TPDFFontDescriptorDef);
  end;

  {*
   *  TPDFFont
   *  FontIuWFNgB
   *  ۂ̏FontDefɎ
   *  FontName̓tHg̖(ex. Arial, Century)ł͂ȂPDFt@CŎgp
   *  (ex /F0, /F1)B
   *
   *}
  TPDFFont = class(TPDFObject)
  private
    FFontDef: TPDFFontDef;
    FFontDescriptor: TPDFFontDescriptor;
    FDescendantFont: TPDFFont;
    FFontName: integer;
    function GetFontID: TPDFFontID;
  protected
    function GetObjectDetail: string; override;
    function GetCharWidth(C: Char): integer;
  public
    constructor Create(AOwner: TPDFMaker); override;
    destructor Destroy; override;
    procedure SetFontDef(AFontDef: TPDFFontDef); virtual;
    property FontName: integer read FFontName;
    property FontID: TPDFFontID read GetFontID;
  end;

  {*
   *  TPDFContents
   *  ContentsIuWFNgB
   *  ̃IuWFNgۂɕ`ʂsLoX̖ڂsB
   *
   *}
  TPDFContents = class(TPDFObject)
  private
    FBuf: string;
    { vpeBp̃tB[h }
    FFont: TPDFFontID;
    FFontSize: Single;
    FLineWidth: Single;
    FLineJoinStyle: TLineJoinStyle;
    FLineCapStyle: TLineCapStyle;
    FFillColor: TColor;
    FStrokeColor: TColor;
    FLeading: Single;
    FCharSpace: Single;
    FWordSpace: Single;
    FStateSaved: boolean;
    FHolizontalScaling: Byte;
    { ʃ[` }
    procedure SaveDefaultGState;
    function StrToHex(s: string): string;
    function GetObjectDetail: string; override;
    function GetColorStr(Color: TColor): string;
    function EscapeText(Value: string): string;
  public
    constructor Create(AOwner: TPDFMaker); override;
    {*
     *
     * 'p'Ŏn܂郋[`́APDF̃Iy[^̂܂܏o͂჌x̃[`
     *  ̃[`́AĂяop^ɂĂ͕\ɃG[ɂȂ
     *  ꍇ̂ŒӁB
     *
     *}                                                         {Operator}
    procedure pCFillStroke;                                     {  b     }
    procedure pFillStroke;                                      {  B     }
    procedure pCEofillStroke;                                   {  b*    }
    procedure pEofillStroke;                                    {  B*    }
    procedure pBeginText;                                       {  BT    }
    procedure pCurveTo(x1, y1, x2, y2, x3, y3: Single);         {  c     }
    procedure pConcat(a, b, c, d, e, f: Single);                {  cm    }
    procedure pSetDash(Length1, Length2, Phase: Byte);          {  d     }
    procedure pExecXObject(XObjectID: integer);                 {  Do    }
    procedure pEndText;                                         {  ET    }
    procedure pFillPath;                                        {  f     }
    procedure pEofillPath;                                      {  f*    }
    procedure pClosePath;                                       {  h     }
    procedure pSetFlatness(Value: Single);                      {  i     }
    procedure pSetLineJoin(Value: TLineJoinStyle);              {  j     }
    procedure pSetLineCap(Value: TLineCapStyle);                {  J     }
    procedure pLineTo(x, y: Single);                            {  l     }
    procedure pMoveTo(x, y: Single);                            {  m     }
    procedure pSetMitterLimit(Value: Single);                   {  M     }
    procedure pEndPath;                                         {  n     }
    procedure pSetRGBFillColor(Value: TColor);                  {  rg    }
    procedure pSetRGBStrokeColor(Value: TColor);                {  RG    }
    procedure pClosePathStroke;                                 {  s     }
    procedure pStroke;                                          {  S     }
    procedure pSetCharSpace(Value: Single);                     {  Tc    }
    procedure pMoveTextPoint(x, y: Single);                     {  Td    }
    procedure pSetFontAndSize(AFont: TPDFFontID; ASize: Single);{  Tf    }
    procedure pShowText(Value: string);                         {  Tj    }
    procedure pShowJText(Value: string);                        {  Tj    }
    procedure pSetLeading(Value: Single);                       {  TL    }
    procedure pSetTextRendering(Value: TTextRenderingMode);     {  Tr    }
    procedure pSetWordSpace(Value: Single);                     {  Tw    }
    procedure pSetHolizontalScaling(Value: Byte);               {  Tz    }
    procedure pMoveToNextLine;                                  {  T*    }
    procedure pSetLineWidth(Value: Single);                     {  w     }
    procedure pClip;                                            {  W     }
    procedure pSaveGState;                                      {  q     }
    procedure pRestoreGState;                                   {  Q     }
    procedure pEoclip;                                          {  W*    }
    procedure pTextShowNextLine(Value: string);                 {  '     }
    procedure pJTextShowNextLine(Value: string);                {  '     }
    {*
     *  W`惋[`
     *}
    function TextWidth(S: string): Single;
    function MeasureText(S: string; AWidth: Single): integer;
    function ArrangeText(Src: string; var Dst: string; AWidth: Single): integer;
    procedure LineTo(x1, y1, x2, y2: Single);
    procedure DrawRect(x1, y1, x2, y2: Single; Clip: boolean);
    procedure FillRect(x1, y1, x2, y2: Single; Clip: boolean);
    procedure DrawAndFillRect(x1, y1, x2, y2: Single; Clip: boolean);
    procedure TextOut(X, Y: Single; Text: string);
    procedure CancelClip;
    procedure DrawXObject(X, Y, AWidth, AHeight: Single; XObjectID: Integer);
    {*
     *  W`ʃ[`p̃vpeB
     *}
    property Font: TPDFFontID read FFont write FFont;
    property FontSize: Single read FFontSize write FFontSize;
    property LineWidth: Single read FLineWidth write FLineWidth;
    property LineJoinStyle: TLineJoinStyle read FLineJoinStyle write FLineJoinStyle;
    property LineCapStyle: TLineCapStyle read FLineCapStyle write FLineCapStyle;
    property FillColor: TColor read FFillColor write FFillColor;
    property StrokeColor: TColor read FStrokeColor write FStrokeColor;
    property Leading: Single read FLeading write FLeading;
    property CharSpace: Single read FCharSpace write FCharSpace;
    property WordSpace: Single read FWordSpace write FWordSpace;
    property HolizontalScaling: Byte read FHolizontalScaling write FHolizontalScaling;
  end;

  {*
   *  TPDFPage
   *  PageIuWFNgB
   *
   *}
  TPDFPage = class(TPDFObject)
  private
    FContents: TPDFContents;
    FParent: TPDFPages;
    function GetObjectDetail: string; override;
  public
    constructor Create(AOwner: TPDFMaker); override;
    procedure SetParent(AParent: TPDFPages);
    property Contents: TPDFContents read FContents;
  end;

  TPDFOutLineTree = class;

  {*
   *  TPDFCatalog
   *  CatalogIuWFNgB
   *
   *}
  TPDFCatalog = class(TPDFObject)
  private
    FPagesObject: TPDFPages;
    FOutLines: TPDFOutLineTree;
    function GetObjectDetail: string; override;
  public
    constructor Create(AOwner: TPDFMaker); override;
    destructor Destroy; override;
    property Pages: TPDFPages read FPagesObject;
    property OutLines: TPDFOutLineTree read FOutLines;
  end;

  TPDFXObject = class;
  TPDFImage = class;

  {*
   *  TPDFMaker
   *
   *}
  TPDFMaker = class(TObject)
  public
  private
    FStream: TStream;
    FRoot: TPDFCatalog;
    FObjectList: TPDFObjectList;
    FFonts: TPDFObjectList;
    FXObjects: TPDFObjectList;
    FCanvas: TPDFContents;
    FCurrentPage: TPDFPage;
    FInfo: TPDFInfo;
    FAuthor: string;
    FTitle: string;
    FCreator: string;
    FSubject: string;
    FFontsStatus: array[0..MAX_PDF_FONT_INDEX] of boolean;
    FPrinting: boolean;
    FPage: integer;
    FPageWidth: Integer;
    FPageHeight: Integer;
    FUseOutLines: boolean;
    function GetCanvas: TPDFContents;
    function GetCurrentPage: TPDFPage;
    function GetOutLines: TPDFOutLineTree;
    procedure SetPageHeight(Value: Integer);
    procedure SetPageWidth(Value: Integer);
  protected
    function RegisterObject(AObject: TPDFObject): integer;
    function RegisterFont(AFont: TPDFFont): integer;
    function GetFont(FontID: TPDFFontID): TPDFFont;
    function GetFontNameList: string;
    function GetXObjectList: string;
    function GetXObjectsCount: integer;
    function UseText: boolean;
    function UseImageC: boolean;
    procedure WriteObject;
    procedure ClearObject;
    procedure CheckStatus;
  public
    constructor Create;
    destructor Destroy; override;
    procedure BeginDoc(AStream: TStream);
    procedure EndDoc(ACloseStream: boolean);
    procedure NewPage;
    function CreateXObject(Image: TPDFImage): TPDFXObjectHandle;
    property Canvas: TPDFContents read GetCanvas;
    property CurrentPage: TPDFPage read GetCurrentPage;
    property OutLines: TPDFOutLineTree read GetOutLines;
    property Author: string read FAuthor write FAuthor;
    property Title: string read FTitle write FTitle;
    property Creator: string read FCreator write FCreator;
    property Subject: string read FSubject write FSubject;
    property Page: integer read FPage;
    property PageHeight: integer read FPageHeight write SetPageHeight;
    property PageWidth: integer read FPageWidth write SetPageWidth;
    property UseOutLines: boolean read FUseOutLines write FUseOutLines;
  end;

  {*
   *  TPDFOutLineEntry
   *    AEgC̊em[hǗIuWFNg(V0.5`)
   *
   *}
  TPDFOutLineEntry = class(TPDFObject)
  private
    FParent: TPDFOutLineEntry;
    FPrev: TPDFOutLineEntry;
    FNext: TPDFOutLineEntry;
    FFirst: TPDFOutLineEntry;
    FLast: TPDFOutLineEntry;
    FDestPage: TPDFPage;
    FXPos: Single;
    FYPos: Single;
    FOpened: boolean;
    Ftitle: string;
  protected
    property Parent: TPDFOutLineEntry read FParent write FParent;
    property Prev: TPDFOutLineEntry read FPrev write FPrev;
    property Next: TPDFOutLineEntry read FNext write FNext;
    property First: TPDFOutLineEntry read FFirst write FFirst;
    property Last: TPDFOutLineEntry read FLast write FLast;
    property Dest: TPDFPage read FDestPage write FDestPage;
    function GetVisibleKidsCount: integer;
    function GetObjectDetail: string; override;
  public
    constructor Create(AOwner: TPDFMaker); override;
    property Opened: boolean read FOpened write FOpened;
    property Title: string read FTitle write FTitle;
    property XPos: Single read FXPos write FXPos;
    property YPos: Single read FYPos write FYPos;
  end;

  {*
   *  TPDFOutLineTree
   *    TPDFOutLineEntry̏WǗIuWFNg(V0.5`)
   *
   *}
  TPDFOutLineTree = class(TObject)
  private
    FOwner: TPDFMaker;
    FRootEntry: TPDFOutLineEntry;
  public
    constructor Create(AOwner: TPDFMaker);
    function AddEntry(AParent: TPDFOutLineEntry; ATitle: string;
                      AXPos, AYPos: Single; AOpened: boolean): TPDFOutLineEntry;
    property RootEntry: TPDFOutLineEntry read FRootEntry;
  end;

  {*
   *  TPDFXObject
   *    Imagef[^ǗIuWFNg(V0.6`)
   *
   *}
  TPDFXObject = class(TPDFObject)
  private
    FXObjectID: Integer;
    FImage: TPDFImage;
  protected
    function GetObjectDetail: string; override;
    property XObjectID: integer read FXObjectID write FXObjectID;
  public
    constructor Create(AOwner: TPDFMaker); override;
    destructor Destroy; override;
    procedure SetImage(AImage: TPDFImage);
  end;

  {*
   *  TPDFImage
   *    摜f[^}邽߂̒ۃIuWFNg
   *@@ۂɉ摜gp邽߂ɂ́ÃNXpNXB
   *    Exet@C̃TCY邽߁APDFMakerƂ͕ʃjbgŎ
   *
   *}
  TPDFImage = class(TObject)
  protected
    function GetWidth: integer; virtual;
    function GetHeight: integer; virtual;
    function GetImage: string; virtual;
    function GetBitsPerComponent: integer; virtual;
    function GetColorSpace: string; virtual;
  public
    property Width: integer read GetWidth;
    property Height: integer read GetHeight;
    property ImageBuf: string read GetImage;
    property ColorSpace: string read GetColorSpace;
    property BitsPerComponent: integer read GetBitsPerComponent;
  end;

  function PDFRect(Left, Top, Right, Bottom: Single): TPDFRect;
  function PDFPoint(x, y: Single): TPDFPoint;
  function StrToUnicodeHex(Value: string): string;

implementation

const
  CRLF = #13#10;
  CR = #13;

{* common routines *}
function PDFRect(Left, Top, Right, Bottom: Single): TPDFRect;
begin
  Result.Left := Left;
  Result.Top := Top;
  Result.Right := Right;
  Result.Bottom := Bottom;
end;

function PDFPoint(x, y: Single): TPDFPoint;
begin
  Result.X := x;
  Result.Y := y;
end;

function PDFRectToString(ARect: TPDFRect): string;
begin
  result := '[ ' + FloatToStr(ARect.Left) +
            ' ' + FLoatToStr(ARect.Top) +
            ' ' + FLoatToStr(ARect.Right) +
            ' ' + FLoatToStr(ARect.Bottom) + ' ]';
end;

function RectToString(ARect: TRect): string;
begin
  result := '[ ' + IntToStr(ARect.Left) +
            ' ' + IntToStr(ARect.Top) +
            ' ' + IntToStr(ARect.Right) +
            ' ' + IntToStr(ARect.Bottom) + ' ]';
end;

function PDFPointToString(APoint: TPDFPoint): string;
begin
  result := '[ ' + FLoatToStr(APoint.X) +
            ' ' + FLoatToStr(APoint.Y) + ' ]';
end;

function FloatToStrR(Value: Extended): string;
begin
  {*
   * Qʈȉľܓ
   *
   *}
  result := FloatToStr(Trunc(Value * 100 + 0.5) / 100);
end;

function StrToUnicodeHex(Value: string): string;
var
  Buf: array[0..1024] of char;
  Len: integer;
  i: integer;
begin
  result := 'FEFF001B6A61001B';
 // Valueŗ^ꂽUniCodeɕϊ
  Len := MultiByteToWideChar(0, 0, PChar(Value), Length(Value), @Buf, 1024);
  i := 0;
  {*
   * ϊꂽ16i\ɕϊďʃoCgƉʃoCgւB
   * Ȃœւ邩͂킩ȂB
   *}
  while i < Len * 2 do
  begin
    result := result + IntToHex(Ord(Buf[i+1]), 2) + IntToHex(Ord(Buf[i]), 2);
    inc(i, 2);
  end;
end;

{*
 * TPDFObject
 *
 *}
constructor TPDFObject.Create(AOwner: TPDFMaker);
begin
  FOwner := AOwner;
  FObjectID := AOwner.RegisterObject(Self);
end;

function TPDFObject.GetObjectHeader: string;
begin
  result := IntToStr(FObjectID) + ' 0 obj' + CRLF;
end;

function TPDFObject.GetObjectDetail: string;
begin
  result := '';
end;

function TPDFObject.GetObjectString: string;
begin
  result := GetObjectHeader +
            GetObjectDetail +
            'endobj' + CRLF;
end;

{*
 *  TPDFObjectList
 *
 *}
constructor TPDFObjectList.Create;
begin
  FItems := TList.Create;
  FItems.Clear;
end;

destructor TPDFObjectList.Destroy;
begin
  FItems.Free;
  inherited;
end;

function TPDFObjectList.AddItem(AItem: TPDFObject): integer;
begin
  if (AItem <> nil) and (AItem is TPDFObject) then
    result := FItems.Add(AItem)
  else
    result := -1;
end;

function TPDFObjectList.GetItem(Index: integer): TPDFObject;
begin
  if (Index < FItems.Count) and (Index >= 0) then
    result := TPDFObject(FItems[Index])
  else
    raise Exception.CreateFmt('Internel Error Invalid Index %d', [Index]);
end;

function TPDFObjectList.GetCount: integer;
begin
  result := FItems.Count;
end;

function TPDFObjectList.GetArrayString: string;
var
  i: integer;
begin
  result := '[';
  for i := 0 to FItems.Count - 1 do
    result := result + IntToStr(Items[i].ObjectID) + ' 0 R ';
  result := result + ']'
end;

procedure TPDFObjectList.Clear;
begin
 {*
  *  IuWFNg̃XgNAB
  *  Xg̃IuWFNĝ͕̉ʓrsKvB
  *
  *}
  FItems.Clear;
end;

{*
 * TPDFMaker
 *
 *}
function TPDFMaker.GetCanvas: TPDFContents;
begin
  if FCanvas = nil then
    raise Exception.Create('BeginDocĂяoĂ܂');
  result := FCanvas;
end;

function TPDFMaker.GetCurrentPage: TPDFPage;
begin
  if FCurrentPage = nil then
    raise Exception.Create('BeginDocĂяoĂ܂');
  result := FCurrentPage;
end;

function TPDFMaker.GetOutLines: TPDFOutLineTree;
begin
  if not UseOutLines then
    raise Exception.Create('UseOutLinesvpeBfalse̎OutLine͎gpł܂');
  result := FRoot.OutLines;
end;

procedure TPDFMaker.SetPageHeight(Value: Integer);
begin
  if FCanvas <> nil then
    raise Exception.Create('o͒̓TCYύX͂ł܂B');
  if Value > 0 then
    FPageHeight := Value;
end;

procedure TPDFMaker.SetPageWidth(Value: Integer);
begin
  if FCanvas <> nil then
    raise Exception.Create('o͒̓TCYύX͂ł܂B');
  if Value > 0 then
    FPageWidth := Value;
end;

function TPDFMaker.RegisterObject(AObject: TPDFObject): integer;
begin
  result := FObjectList.AddItem(AObject) + 1;
end;

function TPDFMaker.RegisterFont(AFont: TPDFFont): integer;
begin
  {*
   *  AFontŎw肳ꂽtHgtHgBXgɓo^B
   *  resultPDFt@CŎgptHgɂȂB
   *
   *}
  result := FFonts.AddItem(AFont);
end;

function TPDFMaker.GetFontNameList: string;
var
  i: integer;
begin
  result := '';
  for i := 0 to FFonts.Count - 1 do
    result := Result + '/F' + IntToStr(TPDFFont(FFonts[i]).FontName) +
              ' ' + IntToStr(TPDFFont(FFonts[i]).ObjectID) + ' 0 R' + CRLF;
end;

function TPDFMaker.GetFont(FontID: TPDFFontID): TPDFFont;
var
  PDFFont: TPDFFont;
  i: integer;
begin
  {*
   * w肳ꂽFontgpĂȂ쐬ēo^
   * ɎgpĂ炻FontTĕԂ
   *
   *}
  result := nil;
  if not FFontsStatus[ord(FontID)] then
  begin
    PDFFont := TPDFFont.Create(Self);
    PDFFont.FFontName := RegisterFont(PDFFont);
    PDFFont.SetFontDef(CreateFont(FontID));
    FFontsStatus[ord(FontID)] := true;
    result := PDFFont;
  end
  else
    for i := 0 to FFonts.Count - 1 do
      if TPDFFont(FFonts[i]).FontID = FontID then
      begin
        result := TPDFFont(FFonts[i]);
        break;
      end
end;

function TPDFMaker.GetXObjectList: string;
var
  i: integer;
begin
  result := '';
  for i := 0 to FXObjects.Count - 1 do
    result := Result + '/Im' + IntToStr(TPDFXObject(FXObjects[i]).XObjectID) +
              ' ' + IntToStr(TPDFXObject(FXObjects[i]).ObjectID) + ' 0 R' + CRLF;
end;

function TPDFMaker.GetXObjectsCount: integer;
begin
  result := FXObjects.Count;
end;

function TPDFMaker.UseText: boolean;
begin
  if FFonts.Count > 0 then
    result := true
  else
    result := false;
end;

function TPDFMaker.UseImageC: boolean;
begin
  if FXObjects.Count > 0 then
    result := true
  else
    result := false;
end;

constructor TPDFMaker.Create;
begin
  FObjectList := TPDFObjectList.Create;
  FFonts := TPDFObjectList.Create;
  FXObjects := TPDFObjectList.Create;
  FCanvas := nil;
  FPrinting := false;
  FPageHeight := 842;
  FPageWidth := 596;
end;

destructor TPDFMaker.Destroy;
begin
  ClearObject;
  FFonts.Free;
  FXObjects.Free;
  FObjectList.Free;
  inherited;
end;

procedure TPDFMaker.CheckStatus;
begin
  if FPrinting then
    raise Exception.Create('ɂ͎słȂ\bhł');
end;

procedure TPDFMaker.BeginDoc(AStream: TStream);
var
  i: integer;
begin
  {*
   * eϐāAInfo쐬
   *
   *}
  if AStream = nil then
    raise Exception.Create('Invarid Stream');
  FStream := AStream;
  ClearObject;
  FRoot := TPDFCatalog.Create(Self);
  for i := 0 to MAX_PDF_FONT_INDEX do
    FFontsStatus[i] := false;
  FInfo := TPDFInfo.Create(Self);
  FPage := 0;
  NewPage;
  FPrinting := true;
end;

procedure TPDFMaker.EndDoc(ACloseStream: boolean);
begin
  {*
   * IuWFNgXg[ɏށBACloseStreamTruew肳Ăꍇ
   * ̓Xg[N[YB
   *
   *}
  FPrinting := false;
  { Stream ̉mɂ邽߁Atry`finallyň͂(V0.41) }
  try
    WriteObject;
  finally
    FCanvas := nil;
    if ACloseStream then
      FStream.Free;
  end;
end;

procedure TPDFMaker.NewPage;
begin
  {*
   * ContentsIuWFNgVKɍ쐬
   *
   *}
  FCurrentPage := FRoot.Pages.AddPage;
  FCanvas := FCurrentPage.Contents;
  inc(FPage);
end;

procedure TPDFMaker.ClearObject;
var
  i: integer;
begin
  {*
   * o^ĂSẴIuWFNg폜
   *
   *}
  for i := FObjectList.Count - 1 downto 0 do
    if FObjectList.Items[i] <> nil then
      FObjectList.Items[i].Free;
  FObjectList.Clear;
  FFonts.Clear;
end;

procedure TPDFMaker.WriteObject;
var
  i: integer;
  s: string;
  xrefBuf: string;
  xrefPos: integer;

  procedure WriteHeader;
  var
    S: string;
  begin
    S := '%PDF-1.2 ' + CRLF;
    FStream.Write(PChar(S)^, Length(S));
  end;

  procedure WriteFooter;
  var
    S: string;
  begin
  {*
   *  trailero
   *
   *}
    S := 'trailer' + CRLF +
         '<<' + CRLF +
         '/Size ' + IntToStr(FObjectList.Count+1) + CRLF +
         '/Root ' + IntToStr(FRoot.ObjectID) + ' 0 R' + CRLF +
         '/Info ' + IntToStr(FInfo.ObjectID) + ' 0 R' + CRLF +
         '>>' + CRLF +
         'startxref' + CRLF +
         IntToStr(xrefPos) + CRLF +
         '%%EOF' + CRLF;
    FStream.Write(PChar(S)^, Length(S));
  end;

  function SetAddrLength(Value: integer): string;
  begin
    {*
     *  Valueŗ^ꂽiIuWFNg̃t@C̃AhXj
     *  xrefŎgp10̕ɕϊ
     *
     *}
    result := IntToStr(Value);
    while Length(Result) < 10 do
      Result := '0' + Result;
  end;

begin
  {*
   * Xg̊eIuWFNgGetObjectStringĂяo
   * IuWFNg̓eXg[ɏoB
   * ̎cross refarence table 쐬ďo͌Atb^[o
   *
   *}
  xrefbuf := 'xref' + CRLF + '0 ' + IntToStr(FObjectList.Count+1) + CRLF +
             '0000000000 65535 f' + CRLF;
  FStream.Position := 0;
  WriteHeader;
  for i := 0 to FObjectList.Count - 1 do
  begin
    xrefBuf := xrefBuf + SetAddrLength(FStream.Position) + ' 00000 n' + CRLF;
    s := FObjectList.Items[i].GetObjectString;
    FStream.Write(PChar(s)^, Length(S));
  end;
  xrefPos := FStream.Position;
  FStream.Write(PChar(xrefbuf)^, Length(xrefbuf));
  WriteFooter;
end;

function TPDFMaker.CreateXObject(Image: TPDFImage): TPDFXObjectHandle;
var
  XObject: TPDFXObject;
begin
  XObject := TPDFXObject.Create(Self);
  XObject.SetImage(Image);
  XObject.XObjectID := FXObjects.AddItem(XObject);
  result := XObject.XObjectID;
end;

{* TPDFCatalog *}
constructor TPDFCatalog.Create(AOwner: TPDFMaker);
begin
  inherited Create(AOwner);
  FPagesObject := TPDFPages.Create(AOwner);
  FPagesObject.Width := AOwner.PageWidth;
  FPagesObject.Height := AOwner.PageHeight;
  if AOwner.UseOutLines then
    FOutLines := TPDFOutLineTree.Create(AOwner)
  else
    FOutLines := nil;
end;

destructor TPDFCatalog.Destroy;
begin
  FOutLines.Free;
  inherited;
end;

function TPDFCatalog.GetObjectDetail: string;
begin
  result := '<<' + CRLF +
            '/Type /Catalog' + CRLF +
            '/Pages ' + IntToStr(FPagesObject.ObjectID) + ' 0 R' + CRLF;
  if FOwner.UseOutLines then
    result := result + '/Outlines ' + IntToStr(FOutLines.RootEntry.ObjectID) + ' 0 R' + CRLF +
              '/PageMode /UseOutlines' + CRLF;
  result := result + '>>' + CRLF;
end;

{* TPDFPages *}
constructor TPDFPages.Create(AOwner: TPDFMaker);
begin
  inherited Create(AOwner);
  FKids := TPDFObjectList.Create;
end;

function TPDFPages.GetKids(Index: integer): TPDFObject;
begin
  result := FKids.Items[Index];
end;

function TPDFPages.GetObjectDetail: string;
begin
  result := '<<' + CRLF +
            '/Kids ' + FKids.GetArrayString + CRLF +
            '/Count ' + IntToStr(FKids.Count) + CRLF +
            '/Type /Pages' + CRLF +
            '/MediaBox [ 0 0 ' + IntToStr(FWidth) + ' ' + IntToStr(FHeight) + ' ]' + CRLF +
            '>>' + CRLF;
end;

function TPDFPages.AddPage: TPDFPage;
begin
  result := TPDFPage.Create(FOwner);
  FKids.AddItem(result);
  result.SetParent(Self);
end;

procedure TPDFPages.SetHeight(Value: integer);
begin
  if Value > 0 then
    FHeight := Value;
end;

procedure TPDFPages.SetWidth(Value: integer);
begin
  if Value > 0 then
    FWidth := Value;
end;

{* TPDFPage *}
function TPDFPage.GetObjectDetail: string;
var
  ProcStr: string;
begin
  ProcStr := '/PDF ';
  result := '<<' + CRLF +
            '/Type /Page' + CRLF +
            '/Parent ' + IntToStr(FParent.ObjectID) + ' 0 R' + CRLF +
            '/Resources <<' + CRLF;
  if FOwner.UseText then
  begin
    result := result + '/Font <<' + CRLF +
            FOwner.GetFontNameList +
            '>>' + CRLF;
    ProcStr := ProcStr + '/Text ';
  end;
  if FOwner.UseImageC then
  begin
    result := result + '/XObject <<' + CRLF +
            FOwner.GetXObjectList +
            '>>' + CRLF;
    ProcStr := ProcStr + '/ImageC';
  end;
  result := result + '/ProcSet [ ' + ProcStr + ']' + CRLF +
            '>>'  + CRLF +
            '/Contents ' + IntToStr(FContents.ObjectID) + ' 0 R' + CRLF +
            '>>' + CRLF;
end;

constructor TPDFPage.Create(AOwner: TPDFMaker);
begin
  inherited Create(AOwner);
  FContents := TPDFContents.Create(AOwner);
end;

procedure TPDFPage.SetParent(AParent: TPDFPages);
begin
  FParent := AParent;
end;

{* TPDFContents *}

constructor TPDFContents.Create(AOwner: TPDFMaker);
begin
  inherited Create(AOwner);
  FBuf := '';
  FFont := fiCentury;
  FFontSize := 10;
  FLineWidth := 1;
  FLineJoinStyle := ljMiterJoin;
  FLineCapStyle := lcButtEnd;
  FFillColor := clBlack;
  FStrokeColor := clBlack;
  FLeading := 0;
  FStateSaved := false;
  FHolizontalScaling := 100;
end;

function TPDFContents.GetObjectDetail: string;
const
  LF = #10;
begin
  result := '<<' + CRLF +
            '/Length ' + IntToStr(Length(FBuf)) + CRLF +
            '>>' + CRLF +
            'stream' + CRLF +
            FBuf + LF +
            'endstream' + CRLF;
end;

procedure TPDFContents.SaveDefaultGState;
begin
  {*
   *  ftHgGraphicStateۑBNbsOԂ畜A邽߂
   *  gpB
   *
   *}
  if not FStateSaved then
  begin
    pSaveGState;
    FStateSaved := true;
  end;
end;

procedure TPDFContents.LineTo(x1, y1, x2, y2: Single);
begin
  pMoveTo(x1, y1);
  pSetLineCap(FLineCapStyle);
  pSetRGBStrokeColor(StrokeColor);
  pSetLineWidth(FLineWidth);
  pLineTo(x2, y2);
  pStroke;
  pEndPath;
end;

function TPDFContents.TextWidth(S: string): Single;
var
  i: integer;
  SW: Single;
  FPDFFont: TPDFFont;
begin
  {*
   *  ݂̃tHg̏iށETCYjɁAeLXg̕vZB
   *
   *}
  FPDFFont := FOwner.GetFont(FFont);
  SW := 0;
  i := 1;
  while i <= Length(S) do
  begin
    if (ByteType(S, i) = mbSingleByte) then
    begin
      if i <> 1 then
        SW := SW + FCharSpace;
      SW := SW + FPDFFont.GetCharWidth(S[i]) * FFontSize / 1000;
      if S[i] = ' ' then
        SW := SW + FWordSpace;
    end
    else
    if (ByteType(S, i) = mbTrailByte) and (i > 2) then
      SW := SW + FPDFFont.GetCharWidth(Chr(0)) / 2 * FFontSize / 1000 + FCharSpace
    else
      SW := SW + FPDFFont.GetCharWidth(Chr(0)) / 2 * FFontSize / 1000;
    inc(i);
  end;
  result := SW;
end;

function TPDFContents.MeasureText(S: string; AWidth: Single): integer;
var
  i: integer;
  SW: Single;
  SL: integer;
  FPDFFont: TPDFFont;
begin
  {*
   *  ݂̃tHg̏iށETCYjɁA^ꂽ(Width)
   *  镶oCgŕԂB
   *  [hbvs߂ɎgpB
   *
   *}
  FPDFFont := FOwner.GetFont(FFont);
  SW := 0;
  i := 1;
  result := 0;
  SL := Length(S);
  while i <= SL do
  begin
    if (ByteType(S, i) = mbSingleByte) then
    begin
      if i > 1 then
        SW := SW + FCharSpace;
      SW := SW + FPDFFont.GetCharWidth(S[i]) * FFontSize / 1000;
      if i = SL then
        result := i
      else
      if S[i] = ' ' then
      begin
        SW := SW + FWordSpace;
        result := i;
      end;
    end
    else
    begin
      SW := SW + FPDFFont.GetCharWidth(Chr(0)) / 2 * FFontSize / 1000;
      // QoCg̑ 2 oCgڂALȐ؂ڂɂȂB
      if (ByteType(S, i) = mbTrailByte) then
      begin
        if i > 2 then
          SW := SW + FCharSpace;
        result := i;
      end;
    end;
    inc(i);
    {*
     * w肳ꂽ𒴂炻܂łŃJEg߂邪A𒴂ĂŒPP
     * ͓悤ɂBi[vh~j
     *
     *}
    if (SW > AWidth) and (result > 0) then Exit;
  end;
end;

function TPDFContents.ArrangeText(Src: string; var Dst: string; AWidth: Single): integer;
var
  i, j: integer;
  SubS: string;
begin
  {*
   * w肳ꂽɓ悤SrcœnꂽɉsR[hĐ`
   * `ꂽeLXgDstɓB߂lɂ͐`ꂽ̍sB
   *
   *}
  j := 1;
  result := 0;
  Dst := '';
  while j <= Length(Src) do
  begin
    i := MeasureText(Copy(Src, j, Length(Src) - (j - 1)), AWidth);
    {*
     * ֑iV0.61`j
     * ̍s̓"B","A"̏ꍇ͋IɑO̍sɓ
     *
     *}
    Subs := Copy(Src, j+i, 2);
    if (Length(Src) > i + 1) and (Subs = 'A') or (Subs = 'B') then
      i := i + 2;

    Dst := Dst + Copy(Src, j, i) + #13#10;
    result := result + 1;
    j := j + i;
  end;
end;

procedure TPDFContents.DrawRect(x1, y1, x2, y2: Single; Clip: boolean);
begin
  pMoveTo(x1, y1);
  pSetLineWidth(FLineWidth);
  pSetLineJoin(FLineJoinStyle);
  pSetRGBStrokeColor(FStrokeColor);
  pLineTo(x1, y2);
  pLineTo(x2, y2);
  pLineTo(x2, y1);
  if Clip then
  begin
    SaveDefaultGState;
    pClip;
  end;
  pClosePathStroke;
end;

procedure TPDFContents.FillRect(x1, y1, x2, y2: Single; Clip: boolean);
begin
  pMoveTo(x1, y1);
  pSetLineWidth(FLineWidth);
  pSetLineJoin(FLineJoinStyle);
  pSetRGBFillColor(FFillColor);
  pLineTo(x1, y2);
  pLineTo(x2, y2);
  pLineTo(x2, y1);
  if Clip then
  begin
    SaveDefaultGState;
    pClip;
  end
  else
    pClosePath;
  pFillPath;
end;

procedure TPDFContents.DrawAndFillRect(x1, y1, x2, y2: Single; Clip: boolean);
begin
  pMoveTo(x1, y1);
  pSetLineWidth(FLineWidth);
  pSetLineJoin(FLineJoinStyle);
  pSetRGBFillColor(FFillColor);
  pSetRGBStrokeColor(FStrokeColor);
  pLineTo(x1, y2);
  pLineTo(x2, y2);
  pLineTo(x2, y1);
  if Clip then
  begin
    SaveDefaultGState;
    pClip;
  end
  else
    pClosePath;
  pFillStroke;
end;

procedure TPDFContents.TextOut(X, Y: Single; Text: string);
var
  StrPos, CurPos: integer;
  StrLen: integer;
  procedure InternalTextOut(s: string);
  var
    HasDoubleByteChar: boolean;
    i: integer;
  begin
    {*
     *  񒆂ɂQoCg܂܂ĂꍇpShowJText,
     *  łȂꍇpShowTextŕ`ʂ
     *}
    HasDoubleByteChar := false;
    for i := 1 to Length(s) do
      if ByteType(s, i) <> mbSingleByte then
      begin
        HasDoubleByteChar := true;
        Break;
      end;
    if HasDoubleByteChar then
      pShowJText(s)
    else
      pShowText(s);
  end;
begin
  pBeginText;
  pSetFontAndSize(FFont, FFontSize);
  pSetRGBFillColor(FFillColor);
  pSetLeading(FLeading);
  pSetCharSpace(FCharSpace);
  pSetWordSpace(FWordSpace);
  pMoveTextPoint(X, Y);
  StrPos := 1;
  CurPos := 1;
  StrLen := Length(Text);
  while CurPos <= StrLen do
  begin
    // sR[hɏo
    if Text[CurPos] = #13 then
    begin
      // obt@o
      InternalTextOut(Copy(Text, StrPos, (CurPos-StrPos)));
      // ŏII
      if CurPos >= StrLen then
        Break
      else
      // #10͖
      if Text[(CurPos+1)] = #10 then
        inc(CurPos);
      // ̃obt@̐擪Zbg
      StrPos := CurPos + 1;
      pMoveToNextLine;
    end;
    inc(CurPos);
  end;
  if StrPos < CurPos then
    InternalTextOut(Copy(Text, StrPos, CurPos-1));
  pEndText;
end;

procedure TPDFContents.CancelClip;
begin
  if FStateSaved then
  begin
    pRestoreGState;
    FStateSaved := false;
  end;
end;

procedure TPDFContents.DrawXObject(X, Y, AWidth, AHeight: Single; XObjectID: Integer);
begin
  if (XObjectID < 0) or (XObjectID >= FOwner.GetXObjectsCount) then
    raise Exception.Create('XObjectID');
  pSaveGState;
  pConcat(AWidth, 0, 0, AHeight, X, Y);
  pExecXObject(XObjectID);
  pRestoreGState;
end;

function TPDFContents.GetColorStr(Color: TColor): string;
var
  X: array[0..3] of Byte;
  i: integer;
begin
{*
 * Colorp^ŗ^ꂽFRGBlɕϊAꂼ̒lOP̊Ԃ
 * lɂB
 *
 *}
  i := ColorToRGB(Color);
  Move(i, x[0], 4);
  result := FloatToStrR(X[0] / 255) + ' ' +
            FloatToStrR(X[1] / 255) + ' ' +
            FloatToStrR(X[2] / 255);
end;

function TPDFContents.EscapeText(Value: string): string;
const
  EscapeChars = ['(',')','\'];
var
  i: integer;
begin
{*
 *  EscapeCharsŒ`ꂽeLXg\ŃGXPCvB
 *
 *}
  result := '';
  for i := 1 to Length(Value) do
  begin
    if (Value[i] in EscapeChars) and (ByteType(Value, i - 1) = mbSingleByte) then
       result := result + '\' + Value[i]
    else
       result := result + Value[i];
  end;
end;

function TPDFContents.StrToHex(s: string): string;
var
  i: integer;
begin
{*
 *  16iŃGR[hĕԂB
 *
 *}
  result := '';
  for i := 1 to Length(s) do
    result := result + IntToHex(ord(s[i]), 2);
end;

procedure TPDFContents.pCFillStroke;
begin
  FBuf := FBuf + 'b' + CR;
end;

procedure TPDFContents.pFillStroke;
begin
  FBuf := FBuf + 'B' + CR;
end;

procedure TPDFContents.pCEofillStroke;
begin
  FBuf := FBuf + 'b*' + CR;
end;

procedure TPDFContents.pEofillStroke;
begin
  FBuf := FBuf + 'B*' + CR;
end;

procedure TPDFContents.pBeginText;
begin
  FBuf := FBuf + 'BT' + CR;
end;

procedure TPDFContents.pSetDash(Length1, Length2, Phase: Byte);
var
  s: string;
begin
  s := '[';
  if Length1 > 0 then
    s := s + IntToStr(Length1) + ' ';
  if Length2 > 0 then
    s := s + IntToStr(Length2);
  s := s + ']' + IntToStr(Phase) + ' d' + CR;
  FBuf := FBuf + s;
end;

procedure TPDFContents.pConcat(a, b, c, d, e, f: Single);
begin
  FBuf := FBuf + FloatToStrR(a) +
           ' ' + FloatToStrR(b) +
           ' ' + FloatToStrR(c) +
           ' ' + FloatToStrR(d) +
           ' ' + FloatToStrR(e) +
           ' ' + FloatToStrR(f) +
          ' cm' + CR;
end;

procedure TPDFContents.pCurveTo(x1, y1, x2, y2, x3, y3: Single);
begin
  FBuf := FBuf + FloatToStrR(x1) +
          ' ' + FloatToStrR(y1) +
          ' ' + FloatToStrR(x2) +
          ' ' + FloatToStrR(y2) +
          ' ' + FloatToStrR(x3) +
          ' ' + FloatToStrR(y3) +
          ' c' + CR;
end;

procedure TPDFContents.pFillPath;
begin
  FBuf := FBuf + 'f' + CR;
end;

procedure TPDFContents.pEofillPath;
begin
  FBuf := FBuf + 'f*' + CR;
end;

procedure TPDFContents.pClosePath;
begin
  FBuf := FBuf + 'h' + CR;
end;

procedure TPDFContents.pEndPath;
begin
  FBuf := FBuf + 'n' + CR;
end;

procedure TPDFContents.pEndText;
begin
  FBuf := FBuf + 'ET' + CR;
end;

procedure TPDFContents.pSetFlatness(Value: Single);
begin
  FBuf := FBuf + FloatToStrR(Value) + ' i' + CR;
end;

procedure TPDFContents.pSetLineJoin(Value: TLineJoinStyle);
begin
  FBuf := FBuf + IntToStr(ord(Value)) + ' j' + CR;
end;

procedure TPDFContents.pSetLineCap(Value: TLineCapStyle);
begin
  FBuf := FBuf + IntToStr(ord(Value)) + ' J' + CR;
end;

procedure TPDFContents.pLineTo(x, y: Single);
begin
  FBuf := FBuf + FloatToStrR(x) + ' ' + FloatToStrR(y) + ' l' + CR;
end;

procedure TPDFContents.pMoveTo(x, y: Single);
begin
  FBuf := FBuf + FloatToStrR(x) + ' ' + FloatToStrR(y) + ' m' + CR;
end;

procedure TPDFContents.pSetMitterLimit(Value: Single);
begin
  FBuf := FBuf + FloatToStrR(Value) + ' M' + CR;
end;

procedure TPDFContents.pSetRGBFillColor(Value: TColor);
begin
  FBuf := FBuf + GetColorStr(Value) + ' rg ' + CR;
end;

procedure TPDFContents.pSetRGBStrokeColor(Value: TColor);
begin
  FBuf := FBuf + GetColorStr(Value) + ' RG ' + CR;
end;

procedure TPDFContents.pClosePathStroke;
begin
  FBuf := FBuf + 's' + CR;
end;

procedure TPDFContents.pStroke;
begin
  FBuf := FBuf + 'S' + CR;
end;

procedure TPDFContents.pSetCharSpace(Value: Single);
begin
  FBuf := FBuf + FloatToStrR(Value) + ' Tc' + CR;
end;

procedure TPDFContents.pMoveTextPoint(x, y: Single);
begin
  FBuf := FBuf + FloatToStrR(x) + ' ' + FloatToStrR(y) + ' Td' + CR;
end;

procedure TPDFContents.pSetFontAndSize(AFont: TPDFFontID; ASize: Single);
begin
  FBuf := FBuf + '/F' + IntToStr(FOwner.GetFont(AFont).FontName) +
                                 ' ' + FloatToStrR(ASize) + ' Tf' + CR;
end;

procedure TPDFContents.pExecXObject(XObjectID: integer);
begin
  FBuf := FBuf + '/Im' + IntToStr(XObjectID) + ' Do' + CR;
end;

procedure TPDFContents.pShowText(Value: string);
begin
  FBuf := FBuf + '(' + EscapeText(Value) + ') Tj' + CR;
end;

procedure TPDFContents.pShowJText(Value: string);
begin
{*
 *  {܂񂾕̏óB16iR[hɕϊ"<",">"ň͂
 *
 *}
  FBuf := FBuf + '<' + StrToHex(Value) + '> Tj' + CR;
end;

procedure TPDFContents.pSetLeading(Value: Single);
begin
  FBuf := FBuf + FloatToStrR(Value) + ' TL' + CR;
end;

procedure TPDFContents.pSetTextRendering(Value: TTextRenderingMode);
begin
  FBuf := FBuf + IntToStr(ord(Value)) + ' Tr' + CR;
end;

procedure TPDFContents.pSetWordSpace(Value: Single);
begin
  FBuf := FBuf + FloatToStrR(Value) + ' Tw' + CR;
end;

procedure TPDFContents.pSetHolizontalScaling(Value: Byte);
begin
  FBuf := FBuf + FloatToStrR(Value) + ' Tz' + CR;
end;

procedure TPDFContents.pMoveToNextLine;
begin
  FBuf := FBuf + 'T*' + CR;
end;

procedure TPDFContents.pSetLineWidth(Value: Single);
begin
  FBuf := FBuf + FloatToStrR(Value) + ' w' + CR;
end;

procedure TPDFContents.pClip;
begin
  FBuf := FBuf + 'W' + CR;
end;

procedure TPDFContents.pSaveGState;
begin
  FBuf := FBuf + 'q' + CR;
end;

procedure TPDFContents.pRestoreGState;
begin
  FBuf := FBuf + 'Q' + CR;
end;

procedure TPDFContents.pEoclip;
begin
  FBuf := FBuf + 'W*' + CR;
end;

procedure TPDFContents.pTextShowNextLine(Value: string);
begin
  FBuf := FBuf + '(' + Value + ') ''' + CR;
end;

procedure TPDFContents.pJTextShowNextLine(Value: string);
begin
  FBuf := FBuf + '<' + StrToHex(Value) + '> ''' + CR;
end;

{* TPDFFont *}
constructor TPDFFont.Create(AOwner: TPDFMaker);
begin
  inherited Create(AOwner);
  FFontDescriptor := nil;
  FDescendantFont := nil;
end;

destructor TPDFFont.Destroy;
begin
  if FFontDef <> nil then
    FFontDef.Free;
  inherited;
end;

function TPDFFont.GetFontID: TPDFFontID;
begin
  result := FFontDef.FontID;
end;

procedure TPDFFont.SetFontDef(AFontDef: TPDFFontDef);
begin
  FFontDef := AFontDef;
  { FontDescripterꍇiTrueTypeFont,CIDFontjFontDescripter쐬 }
  if FFontDef.FontDescriptor <> nil then
  begin
    FFontDescriptor := TPDFFontDescriptor.Create(FOwner);
    FFontDescriptor.FFontDescriptorDef := FFontDef.FontDescriptor;
  end;
  { DescendantFontꍇiType0FontjDescendantFont쐬 }
  if FFontDef.DescendantFont <> nil then
  begin
    FDescendantFont := TPDFFont.Create(FOwner);
    FDescendantFont.SetFontDef(FFontDef.DescendantFont);
  end;
end;

function TPDFFont.GetCharWidth(C: Char): integer;
begin
  result := FFontDef.GetCharWidth(C);
end;

function TPDFFont.GetObjectDetail: string;
begin
  result := '<<' + CRLF +
            '/Type /Font' + CRLF +
            '/Name /F' + IntToStr(FontName) + CRLF +
            FFontDef.DetailString;
  if FFontDescriptor <> nil then
    result := result + '/FontDescriptor ' + IntToStr(FFontDescriptor.ObjectID) + ' 0 R' + CRLF;
  if FDescendantFont <> nil then
    result := result + '/DescendantFonts [' + IntToStr(FDescendantFont.ObjectID) + ' 0 R]' + CRLF;

  result := result + '>>' + CRLF;

end;

{* TPDFFontDescriptor *}
function TPDFFontDescriptor.GetObjectDetail: string;
begin
  {*
   * ́AFontDescripterɕKvȍŒ̍ڂĂȂB
   * iǂӖĂȂ̂ŁBj
   *
   *}
  result := '<<' + CRLF +
  '/Type /FontDescriptor' + CRLF +
  '/FontName /' + FFontDescriptorDef.FontName + CRLF +
  '/Flags ' + IntToStr(FFontDescriptorDef.Flags) + CRLF +
  '/FontBBox ' + RectToString(FFontDescriptorDef.FontBBox) + CRLF +
  '/StemV ' + IntToStr(FFontDescriptorDef.StemV) + CRLF +
  '/Ascent ' + IntToStr(FFontDescriptorDef.Ascent) + CRLF +
  '/CapHeight ' + IntToStr(FFontDescriptorDef.CapHeight) + CRLF +
  '/Descent ' + IntToStr(FFontDescriptorDef.Descent) + CRLF +
  '/ItalicAngle ' + IntToStr(FFontDescriptorDef.ItalicAngle) + CRLF +
  '>>' + CRLF;
end;

procedure TPDFFontDescriptor.SetFontDescriptorDef(AFontDescriptorDef: TPDFFontDescriptorDef);
begin
  FFontDescriptorDef := AFontDescriptorDef;
end;

destructor TPDFFontDescriptor.Destroy;
begin
  FFontDescriptorDef.Free;
  inherited;
end;

{* TPDFInfo *}

function TPDFInfo.GetObjectDetail: string;
begin
  result := '<<' + CRLF +
            '/CreationDate (D:' + FormatDateTime('yyyymmddhhnnss', now) + ')' + CRLF +
            '/Creator <' + StrToUnicodeHex(FOwner.Creator) + '>' + CRLF +
            '/Producer (' + PDFMAKER_VERSION_TEXT + ')' + CRLF +
            '/Author <' + StrToUnicodeHex(FOwner.Author) + '>' + CRLF +
            '/Title <' + StrToUnicodeHex(FOwner.Title) + '>' + CRLF +
            '/Subject <' + StrToUnicodeHex(FOwner.Subject) + '>' + CRLF +
            '>>' + CRLF;
end;

{* TPDFOutLineTree *}
constructor TPDFOutLineTree.Create(AOwner: TPDFMaker);
begin
  FOwner := AOwner;
  FRootEntry := TPDFOutLineEntry.Create(AOwner);
end;

function TPDFOutLineTree.AddEntry(AParent: TPDFOutLineEntry; ATitle: string;
                      AXPos, AYPos: Single; AOpened: boolean): TPDFOutLineEntry;
var
  NewEntry: TPDFOutLineEntry;
begin
  {*
   *  OutLineEntrýAAXg{qm[hƂ\ĂB
   *  VKɃm[hǉꍇ́A֌Wm[h̘Ač\B
   *
   *}
  NewEntry := TPDFOutLineEntry.Create(FOwner);
  if AParent = nil then
    AParent := FRootEntry;
  NewEntry.Parent := AParent;
  if AParent.First = nil then
    AParent.First := NewEntry;
  if AParent.Last <> nil then
  begin
    AParent.Last.Next := NewEntry;
    NewEntry.Prev := AParent.Last;
  end;
  AParent.Last := NewEntry;
  NewEntry.Title := ATitle;
  NewEntry.XPos := AXPos;
  NewEntry.YPos := AYPos;
  NewEntry.Opened := AOpened;
  NewEntry.Dest := FOwner.CurrentPage;
  result := NewEntry;
end;

{* TPDFOutLineEntry *}
function TPDFOutLineEntry.GetObjectDetail: string;
var
  KidsCount: integer;
begin
  Result := '<<' + CRLF;
  if FParent = nil then
  begin
    Result := Result + '/Type /Outlines' + CRLF;
    KidsCount := GetVisibleKidsCount;
  end
  else  
  begin
    Result := Result + '/Parent ' + IntToStr(FParent.ObjectID) + ' 0 R ' + CRLF;
    Result := Result + '/Title <' + StrToUnicodeHex(FTitle) + '>' + CRLF;

    if FPrev <> nil then
      Result := Result + '/Prev ' + IntToStr(FPrev.ObjectID) + ' 0 R ' + CRLF;
    if FNext <> nil then
      Result := Result + '/Next ' + IntToStr(FNext.ObjectID) + ' 0 R ' + CRLF;
    Result := Result + '/Dest [ ' + IntToStr(FDestPage.ObjectID) + ' 0 R /XYZ ' +
             FloatToStr(FXPos) + ' ' + FloatToStr(FYPos)  + ' 0 ]' + CRLF;
    KidsCount := GetVisibleKidsCount;
  end;
  if KidsCount <> 0 then
    Result := Result + '/Count ' + IntToStr(KidsCount) + CRLF;
  if FFirst <> nil then
    Result := Result + '/First ' + IntToStr(FFirst.ObjectID) + ' 0 R ' + CRLF;
  if FLast <> nil then
    Result := Result + '/Last ' + IntToStr(FLast.ObjectID) + ' 0 R ' + CRLF;
  Result := Result + '>>' + CRLF;
end;

function TPDFOutLineEntry.GetVisibleKidsCount: integer;
var
  i, TmpKidsCount: integer;
  TmpEntry: TPDFOutLineEntry;
begin
  {*
   *  m[hJĂAqSĂ̐ċAIɐB
   *  Ăꍇ́A-1ԂB
   *
   *}
  i := 0;
  if FFirst <> nil then
  begin
    TmpEntry := FFirst;
    while true do
    begin
      inc(i);
      TmpKidsCount := TmpEntry.GetVisibleKidsCount;
      if TmpKidsCount >= 0 then
        i := i + TmpKidsCount
      else
        i := i - TmpKidsCount;
      if TmpEntry = FLast then Break;
      TmpEntry := TmpEntry.Next;
    end;
  end;
  if Opened then
    result := i
  else
    result := -i;
end;

constructor TPDFOutLineEntry.Create(AOwner: TPDFMaker);
begin
  inherited Create(AOwner);
  FParent := nil;
  FPrev := nil;
  FNext := nil;
  FFirst := nil;
  FLast := nil;
  FDestPage := nil;
  FXPos := 0;
  FYPos := 0;
  FOpened := true;
  Ftitle := '';
end;

{* TPDFXObject *}
function TPDFXObject.GetObjectDetail: string;
const
  LF = #10;
begin
  if not (FImage is TPDFImage) then
    raise Exception.Create('sȃC[Wf[^łD');
  result := '<<' + CRLF +
            '/Type /XObject' + CRLF +
            '/Subtype /Image' + CRLF +
            '/Width ' + IntToStr(FImage.Width) + CRLF +
            '/Height ' + IntToStr(FImage.Height) + CRLF +
            '/BitsPerComponent ' + IntToStr(FImage.GetBitsPerComponent) + CRLF +
            '/ColorSpace /' + FImage.ColorSpace + CRLF +
            '/Filter /ASCIIHexDecode' + CRLF +
            '/Length ' + IntToStr(Length(FImage.ImageBuf)) + CRLF +
            '>>' + CRLF +
            'stream' + CRLF +
            FImage.ImageBuf + LF +
            'endstream' + CRLF;
end;

procedure TPDFXObject.SetImage(AImage: TPDFImage);
begin
  FImage := AImage;
end;

constructor TPDFXObject.Create(AOwner: TPDFMaker);
begin
  inherited Create(AOwner);
  FImage := nil;
end;

destructor TPDFXObject.Destroy;
begin
  if FImage <> nil then
    FImage.Free;
  inherited;
end;

{* TPDFImage *}
function TPDFImage.GetWidth: integer;
begin
  raise Exception.Create('̃\bh̓I[oChKv܂B');
end;

function TPDFImage.GetHeight: integer;
begin
  raise Exception.Create('̃\bh̓I[oChKv܂B');
end;

function TPDFImage.GetImage: string;
begin
  raise Exception.Create('̃\bh̓I[oChKv܂B');
end;

function TPDFImage.GetBitsPerComponent: integer;
begin
  raise Exception.Create('̃\bh̓I[oChKv܂B');
end;

function TPDFImage.GetColorSpace: string;
begin
  raise Exception.Create('̃\bh̓I[oChKv܂B');
end;

end.
